# Change Log

## [HEAD](https://github.com/ideoforms/signal/tree/HEAD)

[Full Changelog](https://github.com/ideoforms/signal/compare/v0.2.0...HEAD)

**New features:**

- BufferRef [\#66](https://github.com/ideoforms/signal/issues/66)
- Node: MouseX/MouseY [\#65](https://github.com/ideoforms/signal/issues/65)
- Example: audio-write-example [\#59](https://github.com/ideoforms/signal/issues/59)
- Buffer: Save to wav file [\#58](https://github.com/ideoforms/signal/issues/58)
- Support for named triggers [\#56](https://github.com/ideoforms/signal/issues/56)
- Integrate with Travis CI [\#54](https://github.com/ideoforms/signal/issues/54)
- Generate visualisation of synthesis graph structure [\#53](https://github.com/ideoforms/signal/issues/53)
- Trigger-based random number generation [\#49](https://github.com/ideoforms/signal/issues/49)
- Naming review [\#44](https://github.com/ideoforms/signal/issues/44)
- Non-realtime processing [\#16](https://github.com/ideoforms/signal/issues/16)

**Fixed bugs:**

- Multiplex cannot be serialised [\#55](https://github.com/ideoforms/signal/issues/55)

## [v0.2.0](https://github.com/ideoforms/signal/tree/v0.2.0) (2016-04-17)
[Full Changelog](https://github.com/ideoforms/signal/compare/v0.1.1...v0.2.0)

**New features:**

- SynthRegistry [\#51](https://github.com/ideoforms/signal/issues/51)
- Further examples [\#48](https://github.com/ideoforms/signal/issues/48)
- Node: MoogVCF [\#43](https://github.com/ideoforms/signal/issues/43)
- Node: Linear scale [\#41](https://github.com/ideoforms/signal/issues/41)
- Node: Support for constant property values [\#39](https://github.com/ideoforms/signal/issues/39)
- Multiplex: Support for std::initializer\_list  [\#37](https://github.com/ideoforms/signal/issues/37)
- Buffer: Fill buffer from a lambda function [\#35](https://github.com/ideoforms/signal/issues/35)
- Buffer: Waveshaper buffers [\#33](https://github.com/ideoforms/signal/issues/33)
- Node: Waveshaper [\#27](https://github.com/ideoforms/signal/issues/27)
- Node: Triangle [\#26](https://github.com/ideoforms/signal/issues/26)
- Node: Saw [\#25](https://github.com/ideoforms/signal/issues/25)
- Node: EQ [\#19](https://github.com/ideoforms/signal/issues/19)
- JSON parsing to load serialised synth graphs [\#17](https://github.com/ideoforms/signal/issues/17)
- SynthDef: Support for named inputs and outputs [\#4](https://github.com/ideoforms/signal/issues/4)
- Support for non-44k samplerates [\#2](https://github.com/ideoforms/signal/issues/2)
- Buffer recording [\#1](https://github.com/ideoforms/signal/issues/1)

**Fixed bugs:**

- Add node-constant operations where node is the RHS operand [\#30](https://github.com/ideoforms/signal/issues/30)
- Prevent a node from being stepped multiple times per tick [\#29](https://github.com/ideoforms/signal/issues/29)
- Rename channels\_out → num\_output\_channels for consistency [\#23](https://github.com/ideoforms/signal/issues/23)

**Closed issues:**

- Update basic nodes to handle multi-channel inputs [\#24](https://github.com/ideoforms/signal/issues/24)

## [v0.1.1](https://github.com/ideoforms/signal/tree/v0.1.1) (2016-03-23)
[Full Changelog](https://github.com/ideoforms/signal/compare/v0.1.0...v0.1.1)

**New features:**

- Incorporate JSON parser library [\#7](https://github.com/ideoforms/signal/issues/7)
- SynthRef [\#3](https://github.com/ideoforms/signal/issues/3)

**Fixed bugs:**

- Correct loading of multichannel buffers [\#18](https://github.com/ideoforms/signal/issues/18)

## v0.0.1 (2016-01-01)

**New features:**

- Basic framework with `Node` and `Graph` classes
- Automatic reference counting with `NodeRef` as a subclass of `std::shared_ptr`
- Synthesis nodes: `Sine`, `Square`, `Granulator`, `Wavetable`
- Control nodes: `Tick`, `Line`, `ASR`
- Effects nodes: `Delay`, `Gate`, `Pan`, `Resample`, `Width`
- Chance nodes: `Dust`, `Noise`
- `Buffer` object to store fixed buffers of sample data
- `RingBuffer` for circular buffering
- Global `Registry` to store and instantiate `Node` objects by identifier
- Fast Fourier Transform (`FFT`) and inverse FFT (`IFFT`) nodes with Accelerate optimisation
- Operator overloading for node addition, multiplication, addition and subtraction
- Node output monitoring
- Cross-platform I/O with `libsoundio` 
- Audio file I/O with `libsndfile`
- waf-based build system
- Raspberry Pi support


\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*